//
// Main.java: Class file for WO Component 'Main'
// Project RIChecker
//
// Created by paul on Wed Nov 07 2001
//
 
import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import com.webobjects.eocontrol.*;
import com.webobjects.eoaccess.*;

public class Main extends WOComponent {

    protected EOEntity entity;
    protected EOEntity selectedEntity;
    protected EOModel model;
    protected EOModel selectedModel;
    protected String frameworkFileName;
    protected String modelFileName;
    protected NSData modelData;

    public Main(WOContext context) {
        super(context);
//        modelFileName = "c:/tests/PressVault.eomodeld";
//        modelFileName = "c:/";
        modelFileName = "";
        loadModel(modelFileName);
    }

    public CheckEntity checkEntity() {
        CheckEntity nextPage = (CheckEntity)pageWithName("CheckEntity");

        // Initialize your component here
//        debugString("selected entity: " + selectedEntity.name());
        nextPage.setEntity(selectedEntity);

        return nextPage;
    }

    public WOComponent selectModel() {
        if (model == null) {
            NSArray models = EOModelGroup.defaultGroup().models();
            if (models != null && models.count() > 0)
                model = (EOModel)models.objectAtIndex(0);
        }
        selectedModel = model;
        selectedEntity = null;
        if (model != null && model.entities().count() > 0)
            selectedEntity = (EOEntity)model.entities().objectAtIndex(0);
        return null;
    }

    public NSArray models() {
        return EOModelGroup.defaultGroup().models();
    }

    public WOComponent loadModel(String path) {
//        debugString("Path: " + path);
        try {
            EOModelGroup.defaultGroup().addModelWithPath(path);
        } catch (Exception e) {
            logString("Can't load model: " + e.getMessage());
        }
        selectModel();
        return null;
    }

    public WOComponent updateClicked() {
        return null;
    }

    public WOComponent modelSelectionClicked() {
        return loadModel(modelFileName);
    }

    public WOComponent frameworkSelectionClicked() {
        if (NSBundle.bundleWithPath(frameworkFileName) == null || !NSBundle.bundleWithPath(frameworkFileName).load()) {
            logString("Can't load framework: " + frameworkFileName);
        }
        return null;
    }

}
