//
// RIPrimaryKey.java
// Project RIChecker
//
// Created by paul on Wed Nov 07 2001
//

import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import com.webobjects.eocontrol.*;
import com.webobjects.eoaccess.*;
import java.util.*;

public class RIPrimaryKey extends RIKey {

    protected NSArray dupes;

    public RIPrimaryKey(EOEntity value) {
        setEntity(value);
        ec = new EOEditingContext();
    }
    
    public RIPrimaryKey() {
        ec = new EOEditingContext();
    }

    public NSArray keys() {
        NSMutableArray attributeNames = new NSMutableArray();
        Enumeration i = entity.primaryKeyAttributes().objectEnumerator();
        while (i.hasMoreElements()) {
            EOAttribute a = (EOAttribute)i.nextElement();
            attributeNames.addObject(a.columnName());
        }
        return new NSArray(attributeNames);
    }

    public String key() {
        return keys().componentsJoinedByString(",");
    }

    public NSArray dupes() {
        return dupes;
    }

    public boolean checkIntegrity() {
        dupes = null;

        System.err.println("primary key: " + key());
        int result = 0;
        result += checkForDupes();
        if (result > 0) return true;
        return super.checkIntegrity();
    }

    public int checkForDupes() {
        // select Key, count(*) from Table group by Key having count(*) > 1
        String sqlString = "select " + key() + ", count(*) from " + table() + " group by " + key() + " having count(*) > 1";
        System.err.println("SQL: " + sqlString);
        try {
        dupes = EOUtilities.rawRowsForSQL(ec, modelName(), sqlString);
        } catch (Exception e) {
            dupes = new NSArray();
            errors += "SQL exception: " + e.getMessage() + "\n";
            System.err.println(errors);
        }
        System.err.println("Dupes: " + dupes);
        return dupes.count();
    }

}
